## rswipl 9.1.4

=== DESCRIPTION ===
Package: rswipl
Type: Package
Title: Embed 'SWI'-'Prolog'
Version: 9.1.4
Date: 2023-01-27
Authors@R: c(person("Matthias", "Gondan", role = c("aut", "com", "cre"), email = "Matthias.Gondan-Rochon@uibk.ac.at", comment = "Universität Innsbruck"),
  person("Jan", "Wielemaker", role = c("ctb", "cph"), email = "jan@swi-prolog.org", comment = "JW is the lead developer of SWI-Prolog. See https://www.swi-prolog.org/Contributors.html for a list of contributors."))
Maintainer: Matthias Gondan <Matthias.Gondan-Rochon@uibk.ac.at>
Description: Interface to 'SWI'-'Prolog', <https://www.swi-prolog.org/>. This package is normally not loaded directly, please refer to package 'rolog' instead. The purpose of this package is to provide the 'Prolog' runtime on systems that do not have a software installation of 'SWI'-'Prolog'.
License: FreeBSD
Imports: Rcpp (>= 1.0.7)
Depends: R (>= 4.2)
URL: https://github.com/mgondan/rswipl
BugReports: https://github.com/mgondan/rswipl/issues
LinkingTo: Rcpp
RoxygenNote: 7.2.1
Encoding: UTF-8
SystemRequirements: GNU make, CMake (>= 3.10), pandoc, libarchive,
        libregex, libexpat, liblzma, libzstd, liblz4, libz2, libz,
        libbcrypt
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2023-01-27 19:39:07 UTC; gondan
Author: Matthias Gondan [aut, com, cre] (Universität Innsbruck),
  Jan Wielemaker [ctb, cph] (JW is the lead developer of SWI-Prolog. See
    https://www.swi-prolog.org/Contributors.html for a list of
    contributors.)
Repository: CRAN
Date/Publication: 2023-01-27 22:10:02 UTC
