=== src/swipl-devel/debian/changelog ===
swi-prolog (7.1.23-1-g2474030-preciseppa2) precise; urgency=medium

  * New upstream release (from GIT)

 -- Jan Wielemaker <jan@swi-prolog.org>  Sat, 20 Sep 2014 22:50:31 +0200

swi-prolog (7.1.23-0-trustyppa2) trusty; urgency=medium

  * New upstream release (from GIT)

 -- Jan Wielemaker <jan@swi-prolog.org>  Sat, 20 Sep 2014 22:50:01 +0200

swi-prolog (7.1.11-5-g9c58b7c-saucyppa2) saucy; urgency=low

  * New upstream release (from GIT)

 -- Jan Wielemaker <ppa@swi-prolog.org>  Thu, 03 Apr 2014 13:43:02 +0200

swi-prolog (6.3.17-1-gef46fe6-raringppa2) raring; urgency=low

  * New upstream release (from GIT)

 -- Jan Wielemaker <jan@swi-prolog.org>  Fri, 14 Jun 2013 19:51:33 +0200

swi-prolog (6.3.17-0-preciseppa2) precise; urgency=low

  * New upstream release (from GIT)

 -- Jan Wielemaker <jan@swi-prolog.org>  Fri, 14 Jun 2013 16:23:36 +0200

swi-prolog (6.3.16-5-ga7018e1-raringppa2) raring; urgency=low

  * New upstream release (from GIT)

 -- Jan Wielemaker <jan@swi-prolog.org>  Sun, 09 Jun 2013 16:36:41 +0200

swi-prolog (6.2.6-1) experimental; urgency=low

  * New upstream release 

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 10 May 2013 22:36:57 +0200

swi-prolog (6.2.5-6) experimental; urgency=low

  * Fix Vcs-* fields in debian/control (closes: #697420, thanks to Salvatore
    Bonaccorso)
  * Remove pthread-flag-detection.diff - it causes segfaults on Hurd,
    probably because of missing -D_REENTRANT
  * New patch:
    - add-pthread.diff - add -pthread compiler/linker flag when adding
      -D_REENTRANT. This is another attempt to fix FTBFS on Hurd.

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 10 May 2013 22:36:37 +0200

swi-prolog (6.2.5-5) experimental; urgency=low

  * New patch:
    - pthread-flag-detection.diff - do not check for -D_REENTRANT when
      checking for -pthread flag support. This does not work on Hurd.
      See also #697133. 
  * Remove patches not in debian/patches/series:
    - 04_fix_hyphens_being_used_as_minus_signs_in_manpages.diff
    - segstack-alignment.diff
    - swi-prolog-mipsel-FTBFS.diff

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 04 Jan 2013 19:25:41 +0100

swi-prolog (6.2.5-4) experimental; urgency=low

  * Build swi-prolog-java additionally on armhf and s390x - they also have
    OpenJDK as default-jdk

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 01 Jan 2013 17:27:51 +0100

swi-prolog (6.2.5-3) experimental; urgency=low

  * Build-depend on junit on platforms that have -java package,
    this should fix testsuite failures

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 01 Jan 2013 04:36:49 +0100

swi-prolog (6.2.5-2) experimental; urgency=low

  * Link libjpl.so from the JNI directory, so Java runtime can find it
    without need to modify LD_LIBRARY_PATH
  * Enable checks for jpl package 
  * New patch:
    - java-test-library-path.diff - set LD_LIBRARY_PATH during jpl check
  * Add README.Debian to swi-prolog-java package that describes
    current problems when using Java with SWI Prolog (see also #690734)

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 01 Jan 2013 02:30:17 +0100

swi-prolog (6.2.5-1) experimental; urgency=low

  * New upstream release

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 30 Dec 2012 17:32:47 +0100

swi-prolog (6.2.3-1) experimental; urgency=low

  * New upstream release
  * Remove patches (applied upstream):
    - upstream-6.2.3-pre.diff
    - distclean-fixes.diff 
    - implicit-declarations.diff
    - VEOL2-check.diff
  * Updated patches:
    - default-stack-size.diff
    - no-rpath.diff 

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 25 Nov 2012 16:05:35 +0100

swi-prolog (6.2.2-17) experimental; urgency=low

  * New patch:
    - no-rpath.diff - do not set rpath during compilation
  * Use dh-autoreconf during the package build
  * Pass --enable-shared to configure again 

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 04 Nov 2012 18:10:07 +0100

swi-prolog (6.2.2-16) experimental; urgency=low

  * Show ulimit settings during build (for thread stack size problem
    debugging).
  * Use swipl.sh wrapper to install prolog packages

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 28 Oct 2012 20:57:30 +0100

swi-prolog (6.2.2-14) experimental; urgency=low

  * Refactor prolog package installation code in debian/rules
  * Pass DISABLE_PKGS to configure instead of --without-* (the last one looks
    broken)
  * Install package clpqr into swi-prolog-nox
  * Install package nlp into swi-prolog-nox and run checks for it
  * Install package ssl into swi-prolog-nox
    - build-depend on libssl-dev for it
  * Install package zlib into swi-prolog-nox and run checks for it
    - build-depend on zlib1g-dev
  * Install package R into swi-prolog-nox
  * Install package protobufs into swi-prolog-nox and run checks for it
  * Install package PDT into swi-prolog-nox
  * Install package utf8proc into swi-prolog-nox
  * Add -DMAXPATHLEN=1024 to CPPFLAGS on Hurd (propert fix should be
    implemented later)

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 12 Oct 2012 00:03:53 +0200

swi-prolog (6.2.2-13) experimental; urgency=low

  * Update upstream-6.2.3-pre.diff to commit
    8bb9e550c1a1937be46b9d552afef3c304284466
    - building on hurd should go further
  * New patch:
    - default-stack-size.diff - do not try to set stack size to maximum stack
      size, hopefully fixes FTBFS on mips(el) and kfreebsd-*.

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 10 Oct 2012 22:37:26 +0200

swi-prolog (6.2.2-12) experimental; urgency=low

  * Update upstream-6.2.3-pre.diff to commit
    c8dbddfc2b28a906d7d5539e6fd5d44d1e76b466
    - this should fix build on Hurd
  * New patch:
    - implicit-declarations.diff - fix some implicit function declarations on
      kfreebsd and hurd
    - pkg-config.diff - adjust the .pc file
  * Build-depend on default-jdk instead of openjdk-6-jdk, and make -java
    package depend on default-jre-headless istead of openjdk-6-jre-headless
    (closes: #684310)

