=== src/swipl-devel/src/CMakeLists.txt ===
--- 
+++ 
@@ -174,6 +174,9 @@
 if(MULTI_THREADED)
   list(APPEND SWIPL_DATA_library threadutil.pl thread.pl thread_pool.pl)
 endif()
+if(O_PROFILE)
+  list(APPEND SWIPL_DATA_library prolog_profile.pl)
+endif()
 
 set(SWIPL_DATA_library_lynx format.pl html_style.pl html_text.pl
     pldoc_style.pl)
@@ -353,4 +356,3 @@
 file(WRITE "${CMAKE_BINARY_DIR}/src/swipl.home" "../home\n")
 file(WRITE "${CMAKE_BINARY_DIR}/packages/swipl.home" "../home\n")
 symlink_or_copy(${SWIPL_BOOT_ROOT}/build_home.pl ${CMAKE_BINARY_DIR}/home/swipl.rc)
-symlink_or_copy(${SWIPL_BOOT_ROOT}/build_home.pl ${CMAKE_BINARY_DIR}/home/swipl-win.rc)
